src/main/java/dw2/tema6/common/model/User.java
package dw2.tema6.common.model;

import java.util.List;

import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Inheritance;
import javax.persistence.OneToMany;
import javax.persistence.Transient;

import org.hibernate.annotations.Fetch;
import org.hibernate.annotations.FetchMode;

@Entity
@Inheritance
public class User {
	
	@Id
	@GeneratedValue
	private long code;
	private String name;
	
	@OneToMany(mappedBy="requester", fetch = FetchType.EAGER)
	@Fetch(FetchMode.SUBSELECT)
	private List<ServiceRequest> requests;
	
	public long getCode() {
		return code;
	}
	
	public void setCode(long code) {
		this.code = code;
	}
	
	public String getName() {
		return name;
	}
	
	public void setName(String name) {
		this.name = name;
	}

	public List<ServiceRequest> getRequests() {
		return requests;
	}

	public void setRequests(List<ServiceRequest> requests) {
		this.requests = requests;
	}
	
	/**
	 * @return the requested services completion percentage based on {@link #requests} progress average ranging from 0 to 1
	 * @see ServiceRequest
	 */
	@Transient
	public Float getRequestsProgress() {
		if (requests.size() == 0) return 0f;
		Float progressSum = 0f;
		for (ServiceRequest request : requests) {
			progressSum += request.getProgress();
		}
		return progressSum / requests.size();
	}
}

src/main/java/dw2/tema6/common/controller/LocalizationController.java
package dw2.tema6.common.controller;

import java.util.ArrayList;
import java.util.List;
import java.util.Locale;
import java.util.Map;

import javax.faces.bean.ManagedBean;
import javax.faces.bean.SessionScoped;
import javax.faces.component.UIViewRoot;
import javax.faces.context.FacesContext;
import javax.faces.event.AjaxBehaviorEvent;

import dw2.tema6.common.InteractionManager;

@ManagedBean
@SessionScoped
public class LocalizationController {
	private String currentLanguage;

	public String getCurrentLanguage() {
		if (currentLanguage != null)
			return currentLanguage;
		if (InteractionManager.getCurrentSession().getAttribute("language") == null) {
			InteractionManager.getCurrentSession().setAttribute("language", getViewRoot().getLocale().getLanguage());
		}
		return currentLanguage = (String) InteractionManager.getCurrentSession().getAttribute("language");
	}

	public void setCurrentLanguage(String currentLanguage) {
		this.currentLanguage = currentLanguage;
		getViewRoot().setLocale(new Locale(currentLanguage));
		InteractionManager.getCurrentSession().setAttribute("language", currentLanguage);
	}

	public List<LocalizedLocale> getSupportedLocalizedLocales() {
		List<LocalizedLocale> supportedLocales = new ArrayList<>();
		FacesContext.getCurrentInstance().getApplication().getSupportedLocales()
				.forEachRemaining(locale -> supportedLocales.add(new LocalizedLocale(locale, getCurrentLocale())));
		return supportedLocales;
	}

	public Locale getCurrentLocale() {
		return new Locale(getCurrentLanguage());
	}

	private static UIViewRoot getViewRoot() {
		FacesContext context = FacesContext.getCurrentInstance();
		return context.getViewRoot();
	}

	public class LocalizedLocale {
		private Locale locale;
		private Locale localization;

		public LocalizedLocale(Locale locale, Locale localization) {
			this.locale = locale;
			this.localization = localization;
		}

		public Locale getLocale() {
			return locale;
		}

		public String getLocalizedDisplayLanguage() {
			return locale.getDisplayLanguage(localization);
		}
	}
}

src/main/webapp/WEB-INF/base.xhtml
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml"
	xmlns:f="http://java.sun.com/jsf/core"
	xmlns:h="http://java.sun.com/jsf/html"
	xmlns:ui="http://java.sun.com/jsf/facelets">

<h:head>
	<title><ui:insert name="title">#{strings.common_title}</ui:insert></title>
</h:head>

<h:body>
	<f:view locale="#{localizationController.currentLocale}" />

	<div>
		<h:form>
			<h:outputLabel value="#{strings.language}: " for="language_field" />
			<h:selectOneMenu value="#{localizationController.currentLanguage}"
				id="language_field" onchange="submit()">
				<f:selectItems
					value="#{localizationController.supportedLocalizedLocales}"
					var="localizedLocale"
					itemValue="#{localizedLocale.locale.language}"
					itemLabel="#{localizedLocale.localizedDisplayLanguage}" />
			</h:selectOneMenu>
		</h:form>

		<h:messages />

		<ui:insert name="account_content">
			<h:form>
				<h:commandButton value="#{strings.logout}"
					action="#{authController.deauthenticate}" />
			</h:form>
			<br />

			<h:outputLabel value="#{strings.user_code}: " />
			<h:outputLabel value="#{authController.currentUser.code}" />
			<br />

			<h:outputLabel value="#{strings.name}: " />
			<h:outputLabel value="#{authController.currentUser.name}" />
			<br />

			<h:outputLabel value="#{strings.requests_progress}: " />
			<h:outputLabel value="#{authController.currentUser.requestsProgress}">
				<f:convertNumber type="percent" />
			</h:outputLabel>
		</ui:insert>
	</div>
	<div>
		<ui:insert name="content" />
	</div>
</h:body>
</html>